package com.pj.project.tb_business_car;

import java.util.List;

import com.pj.constants.UserTypeEnum;
import com.pj.project.tb_business.TbBusiness;
import com.pj.project.tb_costomer.TbCostomer;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.project4sp.SP;

import com.pj.current.satoken.StpUserUtil;
import cn.dev33.satoken.annotation.SaCheckPermission;


/**
 * Controller: tb_business_car -- 
 * @author qzy 
 */
@RestController
@RequestMapping("/TbBusinessCar/")
public class TbBusinessCarController {

	/** 底层 Service 对象 */
	@Autowired
	TbBusinessCarService tbBusinessCarService;

	/** 查 - 根据id */
	@RequestMapping("add")
	@SaCheckPermission(TbBusiness.PERMISSION_CODE)
	public AjaxJson add(TbBusinessCar t) throws Exception{
		tbBusinessCarService.add(t);
		return AjaxJson.getSuccess();
	}
	/** 查 - 根据id */
	@RequestMapping("delete")
	@SaCheckPermission(TbBusiness.PERMISSION_CODE)
	public AjaxJson delete(String id) {
		return tbBusinessCarService.deleteCar(id);
	}

	@RequestMapping(value = "findInAndNoBusinessCar")
	public AjaxJson findInAndNoBusinessCar(){
		List<TbBusinessCar>list=tbBusinessCarService.findInAndNoBusinessCar();
		return AjaxJson.getSuccessData(list);
	}

	/** 查 - 根据id */
	@RequestMapping("update")
	@SaCheckPermission(TbBusiness.PERMISSION_CODE)
	public AjaxJson update(TbBusinessCar t){
		tbBusinessCarService.updateCar(t);
		return AjaxJson.getSuccess();
	}
	/** 查 - 根据id */
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
		TbBusinessCar t = tbBusinessCarService.getById(id);
		return AjaxJson.getSuccessData(t);
	}
	/** 改 - 状态(0=否,1=是) */
	@RequestMapping("updateStatus")
	@SaCheckPermission(TbBusiness.PERMISSION_CODE)
	public AjaxJson updateStatus(String id, int value){
		TbBusinessCar t=tbBusinessCarService.getById(id);
		t.setIsLock(value);
		tbBusinessCarService.updateById(t);
		return AjaxJson.getByLine(1);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */  
	@RequestMapping("getList")
	public AjaxJson getList() { 
		SoMap so = SoMap.getRequestSoMap();
        String currentCustomerId = StpUserUtil.getCustomerId();
        if (!currentCustomerId.equals(UserTypeEnum.PLATFORM_ADMIN.getCustomerId())) {
            so.put("customerId",currentCustomerId);
        }
		List<TbBusinessCar> list = tbBusinessCarService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}

	
	
	
	
	// ------------------------- 前端接口 -------------------------
	
	
	/** 改 - 不传不改 [G] */
	@RequestMapping("updateByNotNull")
	public AjaxJson updateByNotNull(Long id){
		AjaxError.throwBy(true, "如需正常调用此接口，请删除此行代码");
		// 鉴别身份，是否为数据创建者 
		long userId = SP.publicMapper.getColumnByIdToLong(TbBusinessCar.TABLE_NAME, "user_id", id);
		AjaxError.throwBy(userId != StpUserUtil.getLoginIdAsLong(), "此数据您无权限修改");
		// 开始修改 (请只保留需要修改的字段)
		SoMap so = SoMap.getRequestSoMap();
		so.clearNotIn("id", "businessId", "carNo", "preInTime", "preOutTime", "realInTime", "realOutTime", "money", "driverPhone").clearNull().humpToLineCase();	
		int line = SP.publicMapper.updateBySoMapById(TbBusinessCar.TABLE_NAME, so, id);
		return AjaxJson.getByLine(line);
	}
	
	
	
	
	
	

}
